package com.company.compkey.entity.key;

import io.jmix.core.MetadataTools;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.Column;
import jakarta.persistence.Embeddable;

import java.util.Objects;

@JmixEntity
@Embeddable
public class TypeCompKey {
	@Column(name = "catalogName", nullable = false, unique = true, length = 50)
	private String catalogName;

	@Column(name = "typeValue", nullable = false, unique = true, length = 30)
	private String typeValue;

	public void setCatalogName(String catalogName) {
		this.catalogName = catalogName;
	}

	public String getCatalogName() {
		return catalogName;
	}

	public String getTypeValue() {
		return typeValue;
	}

	public void setTypeValue(String typeValue) {
		this.typeValue = typeValue;
	}

	@Override
	public int hashCode() {
		return Objects.hash(typeValue, catalogName);
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		TypeCompKey entity = (TypeCompKey) o;
		return Objects.equals(this.typeValue, entity.typeValue) &&
				Objects.equals(this.catalogName, entity.catalogName);
	}

	@InstanceName
	@DependsOnProperties({"catalogName", "typeValue"})
	public String getInstanceName(MetadataTools metadataTools) {
		return String.format("%s %s",
				metadataTools.format(catalogName),
				metadataTools.format(typeValue));
	}
}