package com.company.compkey.view.catalog;

import com.company.compkey.entity.Catalog;
import com.company.compkey.entity.Type;
import com.company.compkey.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.core.DataManager;
import io.jmix.flowui.DialogWindows;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "catalogs/:id", layout = MainView.class)
@ViewController(id = "Catalog_.detail")
@ViewDescriptor(path = "catalog-detail-view.xml")
@EditedEntityContainer("catalogDc")
public class CatalogDetailView extends StandardDetailView<Catalog> {

	@Autowired
	private DataManager dataManager;
	@Autowired
	private DialogWindows dialogWindows;
	@ViewComponent
	private DataGrid<Type> typeDataGrid;

	@Subscribe("typeDataGrid.create")
	protected void onTypeDataGridCreate(final ActionPerformedEvent event) {
		Type typeItem = dataManager.create(Type.class);
		typeItem.setCatalog(getEditedEntity());

		dialogWindows.detail(typeDataGrid)
				.newEntity(typeItem)
				.withParentDataContext(getViewData().getDataContext())
				.open();
	}

	@Subscribe("typeDataGrid.edit")
	public void onTypeDataGridEdit(final ActionPerformedEvent event) {
		Type typeItem = typeDataGrid.getSingleSelectedItem();
		if (typeItem == null) {
			return;
		}
		dialogWindows.detail(typeDataGrid)
				.editEntity(typeItem)
				.withParentDataContext(getViewData().getDataContext())
				.open();
	}

}